﻿namespace UltraGridWithValueList
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;
    //using System.Linq;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(), null);
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add();

            dt.Columns.Add("Day Of Week", typeof(int));
            dt.Columns.Add("Day Value", typeof(int));
            dt.Columns.Add("Day Name", typeof(string));

            dt.Rows.Add(new object[] { 1, 1, "Sunday" });
            dt.Rows.Add(new object[] { 1, 1, "Sunday" });
            dt.Rows.Add(new object[] { 1, 1, "Sunday" });

            return ds;
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            ValueList vl = new ValueList();
            vl.ValueListItems.Add(1, "Sunday");
            vl.ValueListItems.Add(2, "Monday");
            vl.ValueListItems.Add(3, "Tuesday");
            vl.ValueListItems.Add(4, "Wednesday");
            vl.ValueListItems.Add(5, "Thursday");
            vl.ValueListItems.Add(6, "Friday");
            vl.ValueListItems.Add(7, "Saturday");

            e.Layout.Bands[0].Columns["Day Of Week"].ValueList = vl;
            e.Layout.Bands[0].Columns["Day Of Week"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDown;
        }

        private void ultraGrid1_AfterCellListCloseUp(object sender, CellEventArgs e)
        {
            //if (e.Cell.Column.Header.Caption == "Day Of Week")
            //{
            //    this.ultraGrid1.PerformAction(UltraGridAction.ExitEditMode);
            //    e.Cell.Row.Cells["Day Value"].Value = e.Cell.Value;
            //    e.Cell.Row.Cells["Day Name"].Value = e.Cell.Text;
            //}
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            //if (this.ultraGrid1.ActiveCell != null && this.ultraGrid1.ActiveCell.Column.Header.Caption == "Day Of Week")
            //{
            //    this.ultraGrid1.ActiveCell.Row.Cells["Day Value"].Value = this.ultraGrid1.ActiveCell.Value;
            //    this.ultraGrid1.ActiveCell.Row.Cells["Day Name"].Value = this.ultraGrid1.ActiveCell.Text;
            //}
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Header.Caption == "Day Of Week")
            {
                ValueList vl = (ValueList)e.Cell.Column.ValueList;
                int currentValueIndex = vl.FindString(e.Cell.Text);
                object newDataValue = vl.ValueListItems[currentValueIndex].DataValue;
                string newDisplayText = vl.ValueListItems[currentValueIndex].DisplayText;
                e.Cell.Row.Cells["Day Value"].Value = newDataValue;
                e.Cell.Row.Cells["Day Name"].Value = newDisplayText;
            }
        }
    }
}
